/*
#ifndef __WCHMCU_IAP_H__
#define __WCHMCU_IAP_H__
*/
//IAPͨѶԼṹ壬λMCUͬ

#define Uart_Sync_Head1		0x57
#define Uart_Sync_Head2		0xab

/*ΪISP*/
#define		CMD_IAP_PROM		0x80		//ISP
#define		CMD_IAP_ERASE		0x81		//ISP
#define		CMD_IAP_VERIFY   	0x82		//ISPУ
#define		CMD_IAP_END			0x83		//ISP־

/********************************************************************************/
/*
  ʽ˵:
 1, CMD_IAP_END(IAP־):
    ʽ:
        CMD_IAP_END+1ֽݳ+2ֽ״̬.
    :
        
 2, CMD_IAP_VERIFY(IAPУ):
     ʽ:
         CMD_IAP_VERIFY+1ֽݳ+2ֽݵַ+.
    :
        ȷ:0x0000
        :0x0001
 3, CMD_IAP_PROM(IAP):
     ʽ:
         CMD_IAP_PROM+1ֽݳ+2ֽݵַ+.עݸΪ4ֽڵ
     :
        ȷ:0x0000
        :0x0001              
 4, CMD_IAP_ERASE(IAP):
     ʽ:
        CMD_IAP_ERASE+1ֽݳ+2ֽڿʼַһΪ0x0000ֻҪһ
    :
        ȷ:0x0000
        :0x0001              
*/  

#define     UINT8 UCHAR  
#define     IAP_LEN            64

#define mMAX_CMDBUF_LENGTH   60                                        //IAPݻ󳤶
#define mMAX_CMDPKT_LENGTH  (mIAP_COMMAND_HEAD + mMAX_CMDBUF_LENGTH)  //IAPֽ


/*ISPسṹ*/
typedef union _IAP_CMD {
	struct {
		UINT8	cmd;
		UINT8	len;
		UINT8	addr[2];
	} erase;				/**/
	struct {
		UINT8	cmd;
		UINT8	len;
		UINT8	status[2];
	} end;					/**/
	struct {				
		UINT8	cmd;
		UINT8	len;			//ݳ
		UINT8	addr[2];			//Уַ
        UINT8    buf[IAP_LEN-4];        /* У */
	} verify;				/*У*/
	struct {				
		UINT8	cmd;
		UINT8	len;			//ݳ
		UINT8	addr[2];			//ַ
        UINT8    buf[IAP_LEN-4];        /*  */
	}program;				 /**/
	struct {
        UINT8    buf[IAP_LEN];          /* ݰ*/ 
	} other;				/**/					
}IAPCMDS;

#define		IAP_UART_BAUDRATE					57600

//ͨUSBӿںMCUIAP̼IMCUû
DWORD WINAPI IAPFlashDownloadThread(LPVOID lpParameter);